{$pbe ignore}
unit DefScript;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TPSForm = class(TForm)
    pScriptGUI: TPanel;
    FCmdLineParams: TEdit;
    FStartFolder: TEdit;
    FHideWindow: TCheckBox;
    FWaitFor: TCheckBox;
    FFileList: TMemo;
    FExcludeMasks: TMemo;
    FDontExpandMasks: TCheckBox;
    FOutputVar: TComboBox;    
    lbFCmdLineParams: TLabel;
    lbFStartFolder: TLabel;
    lbFFileList: TLabel;
    lbFExcludeMasks: TLabel;
    lbFOutputVar: TLabel;
    sbFStartFolder: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PSForm: TPSForm;

implementation

{$R *.dfm}

{$end pbe ignore}

procedure UpdateCDMLine(Sender:TObject);
begin  
  mFileMask.Lines.Text :=  '';
  edParams.Text := '';
  FPreviewCMDLine.Text := '';
  
  if FFileOrProject.Text <> '' then
  begin
    if FFileOrProject.Text[1] = '"' then
      mFileMask.Lines.Text :=  FFileOrProject.Text
    else
      mFileMask.Lines.Text :=  '"' + FFileOrProject.Text + '"';   
  end;
    
  if FDest.Text <> '' then
  begin
    if FDest.Text[1] = '"' then
      mFileMask.Lines.Text :=  mFileMask.Lines.Text + ' ' + FDest.Text
    else
      mFileMask.Lines.Text :=  mFileMask.Lines.Text + ' "' + FDest.Text + '"';   
  end;
  
  if FWaterMarks.Text <> '' then
    edParams.Text := edParams.Text + ' -wm "' + FWaterMarks.Text + '"';   

  if FCBWarnAsErr.Checked then
     edParams.Text := edParams.Text + ' -we';
  
  FPreviewCMDLine.Text := mFileMask.Lines.Text + edParams.Text; 
  edParams.Text := '%FILE%' + edParams.Text;  
end;

procedure ParseCDMLine;
var
  I: Integer;
  s: string;
begin 
  s := mFileMask.Lines[0];
  //get file or project and optionnaly output file
  I := Pos('" "', s);
  if I = 0 then
    FFileOrProject.Text := Copy(s, 2, Length(s) - 2)
  else
  begin 
    FFileOrProject.Text := Copy(s, 2, I - 2);
    FDest.Text := Copy(s, I + 3, Length(S) - I - 3);
  end;

  s := Trim(edParams.Text);
  //get watermarks name
  I := Pos(' -wm "', s);
  if I <> 0 then
    FWaterMarks.Text := Copy(s, I + 6, (PosEx('"', s, I + 6) - I - 6)); //BUG PosEx return always 0

  //check if settings is enabled
  if Pos(' -we', s) <> 0 then   
    FCBWarnAsErr.Checked := True; 
    
  UpdateCDMLine(nil);
end;

procedure SelectFileClick(Sender:TObject);
var
  s: string;
begin
  s := FFileOrProject.Text;
  // mFileMask.Hint contains the defined file extension filters
  if SelectFile(s, mFileMask.Hint) then    
    FFileOrProject.Text := s;
end;

procedure SelectDestClick(Sender:TObject);
var
  s: string;
begin
  s := FFileOrProject.Text;
  if SelectFile(s, 'EXE DLL files (*.exe;*.dll)|*.exe;*.dll|All files (*.*)|*.*') then    
    FDest.Text := s;
end;

procedure sbFStartFolderClick(Sender:TObject);
var
  s: string;  
  p: TPoint;
begin
  s := FStartFolder.text;    
  p.x := 0;
  p.y := sbFStartFolder.Height;
  p := sbFStartFolder.ClientToScreen(p);
  if BrowseForFolder('Select a directory', s, s, p) then  
    FStartFolder.Text := s;
end;


{---------- SaveSettings: Required method! -------------------------------------
  Here you can transform values from your GUI into the required fields
  of default Precision Builder Express command-line interface.   

  Fields description:  

  edParams.Text [required] 
    - command line parameters for the executed application (defined in action type "Advanced tab")

  mFileMask.Lines.Text [optional] 
    - the list of processed files (or any other parameters), that will be used 
      if edParams.Text contains the %FILE% macro
          
  mExcludeMask.Lines.Text [optional] 
    - the list of excluded masks, that is applied on files list (only if cbDontExpandMask.Checked is False),    
      or copied to the edParams.Text replacing the %EXCLUDE% macro
     
  edStartFolder.Text [optional] 
    - working folder for the executed application

  cbHideWindow.Checked [optional]
    - show or hide the application window 

  cbWaitFor.Checked [optional] 
    - wait for the application completion   

  cbDontExpandMask.Checked [optional] 
    - indicates that PBE should not expand the list of processed files before executing the action
      (let the executed application to handle the masks)

  cbVar.Text [optional]               
    - identifier of the project variable, where the output of application
      will be saved (only applicable when action type "Use output file" is checked)
-------------------------------------------------------------------------------}
procedure SaveSettings;
begin
//  mFileMask.Lines.Text:=FFileList.Lines.Text;
//  mExcludeMask.Lines.Text:=FExcludeMasks.Lines.Text;
//  edParams.Text:=FCmdLineParams.Text;
  edStartFolder.Text:=FStartFolder.Text;
  cbHideWindow.Checked:=FHideWindow.Checked;
  cbWaitFor.Checked:=FWaitFor.Checked;
  cbDontExpandMask.Checked:=FDontExpandMasks.Checked;
  cbVar.Text:=FOutputVar.Text;
end;

{---------- LoadSettings: Required method! -------------------------------------
  Here you can transform the Precision Builder Express command-line interface
  fields into the values of your GUI. See the description of fields above.
-------------------------------------------------------------------------------}
procedure LoadSettings;
begin
//  FCmdLineParams.Text:=edParams.Text;
  FStartFolder.Text:=edStartFolder.Text;
  FHideWindow.Checked:=cbHideWindow.Checked;
  FWaitFor.Checked:=cbWaitFor.Checked;
//  FFileList.Lines.Text:=mFileMask.Lines.Text;
//  FFileList.Hint:=FFileList.Hint+'|'+mFileMask.Hint;
//  FExcludeMasks.Lines.Text:=mExcludeMask.Lines.Text;
//  FExcludeMasks.Hint:=FExcludeMasks.Hint+'|'+mExcludeMask.Hint;
  FDontExpandMasks.Checked:=cbDontExpandMask.Checked;
  if cbVar.Parent=tsCommandLine then
  begin
    FOutputVar.Items.Text:=cbVar.Items.Text;
    FOutputVar.Text:=cbVar.Text;
  end
  else
  begin
    FOutputVar.Visible:=False;
    lbFOutputVar.Visible:=False;
  end;
  
  ParseCDMLine;

  Button1.OnClick := @SelectFileClick;
  Button2.OnClick := @SelectDestClick;
  FFileOrProject.OnChange := @UpdateCDMLine;
  FDest.OnChange := @UpdateCDMLine;
  FWaterMarks.OnChange := @UpdateCDMLine;
  FCBWarnAsErr.OnClick := @UpdateCDMLine;
  sbFStartFolder.OnClick:=@sbFStartFolderClick;
end;

{---------- Main script body ---------------------------------------------------
  Calling the LoadSettings method is required!
-------------------------------------------------------------------------------}
begin
  //debug
//  mFileMask.Lines.Text := '"test" "3TFCCD"';
//  edParams.Text := '%FILE% -wm "tessssst" -we -testignore';
  //-----
  
  LoadSettings;
end.